precision highp float;
varying vec2 textureCoordinate;
varying vec2 bitmapTextureCoordinate;
uniform sampler2D vTexture;
uniform sampler2D vBitmapTexture;
uniform vec4 rect; //x -> l;y -> t;z -> r;w -> b

void main()
{
         gl_FragColor = texture2D(vTexture, textureCoordinate);
         if (bitmapTextureCoordinate.x >= rect.x && bitmapTextureCoordinate.x < rect.z
             && bitmapTextureCoordinate.y >= rect.y && bitmapTextureCoordinate.y < rect.w) {
                 float x_coord = (bitmapTextureCoordinate.x - rect.x) / (rect.z - rect.x);
                 float y_coord = (bitmapTextureCoordinate.y - rect.y) / (rect.w - rect.y);
                 lowp vec4 base = gl_FragColor;
                 lowp vec4 overlay = texture2D(vBitmapTexture, vec2(x_coord,y_coord));
                 mediump float r;
                 if (overlay.r * base.a + base.r * overlay.a >= overlay.a * base.a) {
                         r = overlay.a * base.a + overlay.r * (1.0 - base.a) + base.r * (1.0 - overlay.a);
                 } else {
                         r = overlay.r + base.r;
                 }
                 mediump float g;
                 if (overlay.g * base.a + base.g * overlay.a >= overlay.a * base.a) {
                         g = overlay.a * base.a + overlay.g * (1.0 - base.a) + base.g * (1.0 - overlay.a);
                 } else {
                         g = overlay.g + base.g;
                 }
                 mediump float b;
                 if (overlay.b * base.a + base.b * overlay.a >= overlay.a * base.a) {
                          b = overlay.a * base.a + overlay.b * (1.0 - base.a) + base.b * (1.0 - overlay.a);
                 } else {
                          b = overlay.b + base.b;
                 }
                 mediump float a = overlay.a + base.a - overlay.a * base.a;

                 gl_FragColor = vec4(r, g, b, a);
         }
}