precision highp float;
varying vec2 textureCoordinate;
varying vec2 bitmapTextureCoordinate;
uniform sampler2D vTexture;
uniform sampler2D vBitmapTexture;
uniform vec4 rect; //x -> l;y -> t;z -> r;w -> b

void main()
{
    gl_FragColor = texture2D(vTexture, textureCoordinate);
    if (bitmapTextureCoordinate.x >= rect.x && bitmapTextureCoordinate.x < rect.z
    && bitmapTextureCoordinate.y >= rect.y && bitmapTextureCoordinate.y < rect.w) {
        float x_coord = (bitmapTextureCoordinate.x - rect.x) / (rect.z - rect.x);
        float y_coord = (bitmapTextureCoordinate.y - rect.y) / (rect.w - rect.y);
        lowp vec4 c1 = texture2D(vBitmapTexture, vec2(x_coord,y_coord));
        lowp vec4 c2 = gl_FragColor;
        lowp vec4 outputColor;

        outputColor.r = c1.r + c2.r * c2.a * (1.0 - c1.a);

        outputColor.g = c1.g + c2.g * c2.a * (1.0 - c1.a);

        outputColor.b = c1.b + c2.b * c2.a * (1.0 - c1.a);

        outputColor.a = c1.a + c2.a * (1.0 - c1.a);

        gl_FragColor = outputColor;
    }
}