precision highp float;
varying vec2 textureCoordinate;
varying vec2 bitmapTextureCoordinate;
uniform sampler2D vTexture;
uniform sampler2D vBitmapTexture;
uniform vec4 rect; //x -> l;y -> t;z -> r;w -> b
void main()
{
    gl_FragColor = texture2D(vTexture, textureCoordinate);
    if (bitmapTextureCoordinate.x >= rect.x && bitmapTextureCoordinate.x < rect.z
    && bitmapTextureCoordinate.y >= rect.y && bitmapTextureCoordinate.y < rect.w) {
        float x_coord = (bitmapTextureCoordinate.x - rect.x) / (rect.z - rect.x);
        float y_coord = (bitmapTextureCoordinate.y - rect.y) / (rect.w - rect.y);
        mediump vec4 cl = texture2D(vBitmapTexture, vec2(x_coord,y_coord));
        mediump vec4 whiteColor = vec4(1.0);
        gl_FragColor = whiteColor - ((whiteColor - cl) * (whiteColor - gl_FragColor));
    }
}
