attribute vec4 vPosition;
attribute vec2 vCoord;
varying vec2 textureCoordinate;
uniform mat4 vMatrix;

const int GAUSSIAN_SAMPLES = 9;
uniform vec2 singleStepOffset;
varying vec2 blurCoordinates[GAUSSIAN_SAMPLES];

void main( )
{
    gl_Position = vMatrix*vPosition;
    textureCoordinate = vCoord;

   int multiplier = 0;
   vec2 blurStep;

   for (int i = 0; i < GAUSSIAN_SAMPLES; i++)
   {
	      multiplier = (i - ((GAUSSIAN_SAMPLES - 1) / 2));
	      blurStep = float(multiplier) * singleStepOffset;
	      blurCoordinates[i] = textureCoordinate.xy + blurStep;
   }
}