precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D vTexture;
uniform sampler2D inputImageTexture2;
uniform int faceCnt;
uniform vec2 alignPoint;
uniform vec2 size;
uniform mat4 rotateMatrix;
vec4 blendNormal(vec4 c1, vec4 c2) {
    vec4 outputColor;
    outputColor.r = c1.r + c2.r * c2.a * (1.0 - c1.a);
    outputColor.g = c1.g + c2.g * c2.a * (1.0 - c1.a);
    outputColor.b = c1.b + c2.b * c2.a * (1.0 - c1.a);
    outputColor.a = c1.a + c2.a * (1.0 - c1.a);
    return outputColor;
}
void main() {
    gl_FragColor = texture2D(vTexture, textureCoordinate);
    if (faceCnt < 1) {
        return;
    }
    vec4 originCoord = vec4(textureCoordinate.x, textureCoordinate.y, 0, 1.0);
    originCoord = rotateMatrix * originCoord;
    if (originCoord.x <= (alignPoint.x + size.x * 0.5) && originCoord.x > (alignPoint.x - size.x * 0.5) &&
        originCoord.y <= (alignPoint.y + size.y * 0.5) && originCoord.y > (alignPoint.y - size.y * 0.5)) {

        float x_coord = (originCoord.x - alignPoint.x + size.x * 0.5) / size.x;
        float y_coord = (originCoord.y - alignPoint.y + size.y * 0.5) / size.y;;
        vec2 coordUse = vec2(1.0 - x_coord,1.0 - y_coord);
        vec4 c1 = texture2D(inputImageTexture2, coordUse);
        gl_FragColor = blendNormal(c1, gl_FragColor);
    }

}
